#ifndef DRAWABLE_H
#define DRAWABLE_H

#include <string>

#include "UniqueEntity.h"
#include "Ptr.h"
#include "PtrInterface.h"

namespace GameEngine {

	using namespace Fwk;
	using namespace std;

	class Drawable : public UniqueEntity {
	public:
		virtual void draw() = 0;
		virtual void build() = 0;

	protected:
		Drawable() : UniqueEntity(), drawId_(0) { }
		Drawable(string name) : UniqueEntity(name),	drawId_(0) { }
 
		unsigned int drawId_;
	};
}

#endif