#ifndef PICKER_H
#define PICKER_H

#include <string>
#include <vector>

#include "Ptr.h"
#include "PtrInterface.h"

namespace GameEngine {

	using namespace Fwk;
	using namespace std;

	class Picker : public PtrInterface<Picker> {
	public:
		Picker() : pickedId_(0) { }

		unsigned int pickedId() { return pickedId_; }

		void startPicking(unsigned int clickX, unsigned int clickY);
		void stopPicking();

	protected:
		static const unsigned int PICK_BUFFER_SIZE = 1024;
		static const unsigned int UINT_INITIAL = 0xffffffff;

		unsigned int pickBuffer_[PICK_BUFFER_SIZE];
		unsigned int pickedId_;

		void processHits(int hits);
	};
}

#endif