#ifndef TOWERCOLOR_H
#define TOWERCOLOR_H

#include "Ptr.h"
#include "PtrInterface.h"
#include "Color.h"

namespace GameEngine {

	using namespace Fwk;

	class TowerColor : public Color4 {
	public:
		TowerColor(float r, float g, float b, float a) : Color4(r, g, b, a) { }
		TowerColor(float rr, float gg, float bb) : Color4(r, g, b) { }
		TowerColor() : Color4() { }

		static Ptr<Color4> Gray() { return new Color4(0.5, 0.5, 0.5); }
		static Ptr<Color4> Dust() { return new Color4(0.3, 0.1, 0.0); }
		static Ptr<Color4> Earth() { return new Color4(0.6, 0.3, 0.1); }
		static Ptr<Color4> Fire() { return new Color4(1.0, 0.6, 0.0); }
		static Ptr<Color4> Ice() { return new Color4(0.5, 0.5, 1.0); }
	};
}

#endif