#ifndef UNIQUEENTITY_H
#define UNIQUEENTITY_H

#include <string>

#include "Ptr.h"
#include "PtrInterface.h"

namespace GameEngine {

	using namespace Fwk;
	using namespace std;

	class UniqueEntity : public PtrInterface<UniqueEntity> {
	public:
		void nameIs(string name) { name_ = name; }
		string name() { return name_; }

		unsigned int id() { return id_; }
	protected:
		UniqueEntity() : name_("") { genId(); }
		UniqueEntity(string name) : name_(name) { genId(); }

		void genId() {
			static unsigned int id = 0;
			id++;
			id_ = id;
		}

		unsigned int id_;
		string name_;
	};
}

#endif